/*
  A simple example how wbst.cc is used.
  
  Copyright by Jussi Kujala. 
  Licenced under the GPL. For more information see http://www.gnu.org.
*/
#include <iostream>
#include <sstream>
#include <vector>
#include "wbst.h"
#include "stdlib.h"

using namespace std;

void print_tree(Node* root)
{
  if(root->l!=0)
  {
    cout<<"(";
    print_tree(root->l);
    cout<<")";
  }
  cout<<root->key;
  if(root->r!=0)
  {
    cout<<"(";
    print_tree(root->r);
    cout<<")";
  }
}

void usage()
{
  cout<<"Computes an approximately optimal tree for positive weights."<<endl;
  cout<<"Give weights as parameters, f.e. \"wbst 1 2 3 6\""<<endl;
  exit(0);
}

void parse(int argi,char** argc, vector<Item>& items)
{
  if(argi<2)
  {
    usage();
  }
  for(int i=1;i<argi;i++)
  {
    unsigned weight;
    stringstream(argc[i])>>weight;
    if(weight<1)
      usage();
    items.push_back(Item(i,weight));
  }
}

int main(int argi, char** argc)
{
  //vector of input_items = pair(key,positive weight)
  vector<Item> items;
  parse(argi, argc, items);
  Node* root=wbst(items);
  print_tree(root);
  cout<<endl;
  return 0;
}

